<!----------------------------------------------------------------------------------------------------------------------
  -- AddEditEnvModal
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="add-edit-env-modal">
        <BModal
            ref="addEditModal"
            size="xl"
            no-close-on-backdrop
            no-close-on-esc
            hide-header-close
            ok-only
            ok-variant="secondary"
            ok-title="Close"
        >
            <template #title>
                <Fa icon="edit" />
                Edit Environments
            </template>
            <BFormRow>
                <BCol cols="3">
                    <BCard no-body>
                        <template #header>
                            <BButton
                                class="float-end"
                                variant="primary"
                                size="sm"
                                @click.stop="addNew()"
                            >
                                <Fa icon="plus" />
                                Add
                            </BButton>
                            <h6 class="mt-1">
                                Environments
                            </h6>
                        </template>
                        <BListGroup flush>
                            <BListGroupItem v-if="authEnabled && userEnvs.length" disabled>
                                <span class="font-sm">User Environments</span>
                            </BListGroupItem>
                            <BListGroupItem
                                v-for="env in userEnvs"
                                :key="env.id"
                                :active="isActive(env.id)"
                                @click="selectEnv(env)"
                            >
                                <BButton class="float-end" size="sm" @click.stop="copyEnv(env)">
                                    <Fa icon="copy" />
                                </BButton>
                                <Fa v-if="env.secure" icon="lock" class="text-warning" />
                                <Fa v-else icon="lock-open" class="text-muted" />
                                {{ env.name }}
                            </BListGroupItem>
                            <BListGroupItem v-if="authEnabled && systemEnvs.length" disabled>
                                <span class="font-sm">System Environments</span>
                            </BListGroupItem>
                            <BListGroupItem
                                v-for="env in systemEnvs"
                                :key="env.id"
                                :active="isActive(env.id)"
                                @click="selectEnv(env)"
                            >
                                <BButton class="float-end" size="sm" @click.stop="copyEnv(env)">
                                    <Fa icon="copy" />
                                </BButton>
                                <Fa v-if="env.secure" icon="lock" class="text-warning" />
                                <Fa v-else icon="lock-open" class="text-muted" />
                                {{ env.name }}
                            </BListGroupItem>
                        </BListGroup>
                    </BCard>
                </BCol>
                <BCol>
                    <div v-if="!selectedEnv && !adding" class="text-center">
                        <h4 class="text-center mt-4">
                            Please select an environment to edit, or add a new one.
                        </h4>
                    </div>
                    <div v-else id="edit-form">
                        <BAlert variant="info" :show="selectedIsSystem && !canModifySystem">
                            <Fa icon="info-circle" />
                            You do not have permissions to edit System Environments.
                        </BAlert>
                        <BFormRow>
                            <BCol>
                                <BFormGroup
                                    id="env-name"
                                    description="The name of the environment."
                                    label="Name"
                                    label-for="name-input"
                                >
                                    <BInputGroup>
                                        <BFormInput
                                            id="name-input"
                                            v-model="editEnv.name"
                                            trim
                                            :disabled="isDisabled"
                                            required
                                        />
                                        <BInputGroupText :class="editEnv.secure ? 'text-warning' : ''">
                                            <BFormCheckbox v-model="editEnv.secure" switch :disabled="isDisabled">
                                                Secure
                                            </BFormCheckbox>
                                        </BInputGroupText>
                                    </BInputGroup>
                                </BFormGroup>
                            </BCol>
                            <BCol>
                                <BFormGroup
                                    id="backend"
                                    description="The backend type for this environment."
                                    label="Backend"
                                    label-for="backend-select"
                                >
                                    <BFormSelect
                                        id="backend-select"
                                        v-model="editEnv.backend"
                                        :disabled="isDisabled"
                                        :options="backendTypes"
                                        required
                                    />
                                </BFormGroup>
                            </BCol>
                        </BFormRow>

                        <hr>

                        <h4 class="mb-4">
                            Backend Options <small class="text-muted">({{ editEnv.backend }})</small>
                        </h4>

                        <Component
                            :is="backendOptionsComponent"
                            v-model="editEnv"
                            :disabled="isDisabled"
                        />

                        <hr>
                        <BFormRow>
                            <BCol>
                                <BButton v-if="selectedEnv" variant="danger" :disabled="isDisabled" @click="remove()">
                                    <Fa icon="trash-alt" />
                                    Delete
                                </BButton>
                                <BButton v-else @click="adding = false">
                                    <Fa icon="undo" />
                                    Cancel
                                </BButton>
                            </BCol>
                            <BCol class="clearfix">
                                <BButtonToolbar class="float-end">
                                    <BButton class="me-2" @click="clearEditForm">
                                        <Fa icon="times" />
                                        Clear Form
                                    </BButton>
                                    <BDropdown
                                        v-if="authEnabled && !selectedEnv && canModifySystem"
                                        :variant="adding ? 'success' : 'primary'"
                                        split
                                        right
                                        @click.stop="save()"
                                    >
                                        <template #button-content>
                                            <Fa icon="save" class="me-1" />
                                            <span v-if="adding">Save</span>
                                            <span v-else>Update</span>
                                        </template>
                                        <BDropdownItemButton @click.stop="save('system')">
                                            <Fa icon="save" />
                                            <span v-if="adding">Save System Environment</span>
                                            <span v-else>Update System Environment</span>
                                        </BDropdownItemButton>
                                    </BDropdown>
                                    <BButton
                                        v-else
                                        :variant="adding ? 'success' : 'primary'"
                                        :disabled="isDisabled || !isValid"
                                        @click="save()"
                                    >
                                        <Fa icon="save" class="me-1" />
                                        <span v-if="adding">Save</span>
                                        <span v-else>Update</span>
                                    </BButton>
                                </BButtonToolbar>
                            </BCol>
                        </BFormRow>
                    </div>
                </BCol>
            </BFormRow>
        </BModal>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    #env-name {
        .input-group-text {
            padding: 0.320rem 0.75rem;
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref } from 'vue';
    import { useObservable } from '../../lib/composables/rxjs.js';

    // Managers
    import authMan from '../../lib/managers/auth.js';
    import envMan from '../../lib/managers/environments.js';
    import { hasPerm } from '../../lib/managers/permissions.js';
    import pluginMan from '../../lib/managers/plugin.js';

    // Models
    import { Environment, EnvironmentOptions } from '../../lib/models/environment.js';
    import { BModal } from 'bootstrap-vue-next';

    // Utils
    import { sortBy } from '../../../common/utils/misc.js';
    import { AxiosError } from 'axios';

    // Components
    import NoBackendOptions from './backends/noOptions.vue';
    import RedisBackendOptions from './backends/redisOptions.vue';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const adding = ref(false);
    const selectedEnv = ref<Environment | undefined>(undefined);
    const editEnv = ref<EnvironmentOptions>({
        id: undefined,
        accountID: null,
        name: '',
        host: '',
        port: undefined,
        db: undefined,
        backend: 'redis',
        username: undefined,
        password: undefined,
        secure: false,
    });

    const backendTypes = [
        'null',
        'redis',
        'redis-streams',
    ];

    const backendComponents = {
        'null': NoBackendOptions,
        'redis': RedisBackendOptions,
        'redis-streams': RedisBackendOptions,
    };

    const addEditModal = ref<typeof BModal | null>(null);

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const account = useObservable(authMan.account$);
    const authEnabled = useObservable(authMan.authEnabled$);
    const environments = useObservable(envMan.environments$);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const backendOptionsComponent = computed(() => backendComponents[editEnv.value.backend]);

    const canModifySystem = computed(() =>
    {
        // Simplify
        if(authEnabled.value)
        {
            const perm = adding.value ? 'canAdd' : 'canUpdate';
            return !!(account.value && hasPerm(account.value, `${ perm }/SystemEnvironments`));
        }

        return true;
    });

    const selectedIsSystem = computed(() => selectedEnv.value && !selectedEnv.value?.accountID);

    const isDisabled = computed(() => authEnabled.value && selectedIsSystem.value && !canModifySystem.value);

    const isValid = computed(() => editEnv.value.name.length > 0 && editEnv.value.host.length > 0);

    const userEnvs = computed(() => environments.value
        .filter((env) => env.accountID > 0)
        .sort(sortBy('name')));

    const systemEnvs = computed(() => environments.value
        .filter((env) => env.accountID === null)
        .sort(sortBy('name')));

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function clearEditForm() : void
    {
        editEnv.value = {
            id: undefined,
            accountID: null,
            name: '',
            host: '',
            backend: 'redis',
            port: undefined,
            db: undefined,
            username: undefined,
            password: undefined,
            secure: false,
        };

        selectedEnv.value = undefined;
    }

    function show() : void
    {
        addEditModal.value.show();
    }

    function isActive(id : string) : boolean
    {
        return id === (selectedEnv.value?.id ?? '');
    }

    function selectEnv(env : Environment) : void
    {
        adding.value = false;

        if(env?.id === selectedEnv.value?.id)
        {
            selectedEnv.value = undefined;
            clearEditForm();
        }
        else
        {
            selectedEnv.value = env;
            Object.assign(editEnv.value, env);
        }
    }

    function addNew() : void
    {
        adding.value = true;
        clearEditForm();
        selectedEnv.value = undefined;
    }

    function copyEnv(env : Environment) : void
    {
        adding.value = true;
        Object.assign(editEnv.value, env);
        editEnv.value.name += ' (Copy)';
        editEnv.value.id = undefined;
        selectedEnv.value = undefined;
    }

    async function save(type ?: string) : Promise<void>
    {
        const newEnv = {
            ...editEnv.value,
            port: editEnv.value.port || 6379,
            db: editEnv.value.db || 0,
            accountID: (type === 'system') ? undefined : account.value?.id,
        };

        if(adding.value)
        {
            try
            {
                const env = await envMan.add(newEnv);
                selectEnv(env);
                await pluginMan.onEnvironmentAdded(newEnv.id);
            }
            catch (err)
            {
                if(err instanceof AxiosError)
                {
                    if(err.response?.status === 409)
                    {
                        // $bvToast.toast('An environment with that id already exists.', {
                        //     title: 'Error',
                        //     variant: 'danger',
                        //     solid: true,
                        // });
                    }
                    else
                    {
                        // $bvToast.toast('An unknown error occurred.', {
                        //     title: 'Error',
                        //     variant: 'danger',
                        //     solid: true,
                        // });
                    }
                }
            }
        }
        else
        {
            await envMan.update(newEnv);
            await pluginMan.onEnvironmentUpdated(newEnv.id);
        }
    }

    async function remove() : Promise<void>
    {
        const envId = selectedEnv.value.id;
        await envMan.remove(envId);
        clearEditForm();
        adding.value = false;
        await pluginMan.onEnvironmentDeleted(envId);
    }

    //------------------------------------------------------------------------------------------------------------------

    defineExpose({
        show,
    });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
